package com.me.pacman.entity;

import com.badlogic.gdx.graphics.g2d.SpriteBatch;
import com.badlogic.gdx.graphics.g2d.TextureRegion;
import com.me.pacman.state.LevelState;

public abstract class Entity {

    public LevelState state;
    public float x;
    public float y;
    public int age;

    public Entity(LevelState state, float x, float y) {
        this.state = state;
        this.x = x;
        this.y = y;
        this.age = 0;
    }

    public void render(SpriteBatch batch, int offsetX, int offsetY) {
        batch.draw(getSprite(), (int) (x * 8) + (offsetX - 8), (y * 8) + (offsetY - 8));
    }

    public boolean onSameTile(Entity other) {
        return (int) x == (int) other.x && (int) y == (int) other.y;
    }

    public abstract TextureRegion getSprite();

    public void update(float dt) {
        this.age += 1;
    }

}
